%% workshop 04.09.2018
%dont photoshop it, matlab it! Chiara Magliaro

%% step 1: image contrast enhancement
clear all
clc
close all

URL1 = 'http://s8319.pcdn.co/wp-content/uploads/2013/02/Jonny-099.jpg';
tower = imread(URL1);


%% step2: image contrast enhancement on colour channels
clear all
clc
close all

URL2 = 'https://encrypted-tbn0.gstatic.com/images?q=tbn:ANd9GcTPUaJmVgITPDMGBsE01dLYdsYoVLF9vZ7dwX3BDhK0QXYsszi8VQ';
cocktail = imread(URL2);



%% step3: segmentation 
clear all
clc
close all

URL3 ='https://encrypted-tbn0.gstatic.com/images?q=tbn:ANd9GcTeVZBrPIIT1EoPPfIby-mAjtalDuMfGP7e_UAWTGb0H-AyvuRbZQ';
lizard = imread(URL3);



%% step4: how happy I am?
clear all
clc
close all

URL4 = 'https://cdn.geekwire.com/wp-content/uploads/2016/03/shutterstock_272787503.jpg';
girl = imread(URL4);



%% instagram animals

animals = imread('dog.jpg');

FDetect = vision.CascadeObjectDetector;
BB_face = step(FDetect, girl);

figure,
imshow(girl); hold on
for i = 1:size(BB_face,1)
    rectangle('Position',BB_face(i,:),'LineWidth',4,'LineStyle','-','EdgeColor','b');
end
hold off;

NoseDetect = vision.CascadeObjectDetector('Nose','MergeThreshold',30);
BB_nose=step(NoseDetect, girl);

figure,
imshow(girl); hold on
for i = 1:size(BB_nose,1)
    rectangle('Position',BB_nose(i,:),'LineWidth',4,'LineStyle','-','EdgeColor','b');
end
hold off;

nosepoint = [uint16(BB_nose(1, 2) + BB_nose(1,4)/2) uint16(BB_nose(1, 1) + BB_nose(1,3)/2)];   %righe/colonne

d_foxears = 380-120;  

scale_c = uint16(BB_face(1,3)/d_foxears);
scale_r = uint16(nosepoint(1, 1)/361);

prova = imresize (animals, [size(animals,1)*scale_r size(animals,2)*scale_c]);


fox_nosepoint = [uint16(scale_r*297), uint16(scale_c*258)];

merged = girl;

for i = 1:size(prova,1)-1
    for j = 1:size(prova,2)-1
        if prova(i,j,1) < 240 && prova(i,j,2) < 240 && prova(i,j,3) < 240
            if (i+nosepoint(1,1)-fox_nosepoint(1,1)) ~= 0 && (j+nosepoint(1,2)-fox_nosepoint(1,2)) ~= 0
            merged(abs(i+nosepoint(1,1)-fox_nosepoint(1,1)), abs(j+nosepoint(1,2)-fox_nosepoint(1,2)), :) = prova(i,j,:);
            end;
        end;
    end;
end;

figure, imshow(merged)
